
;***************************   -  ATmega8***************************

;*   - 8,00 
;* ;
;* Main:          
;* EXT_INT1:        
;* OutCommand:       -    
;* ALARM:           
;* TablComm:       
;* CommOut:         

;* FUSES:       BODLEVEL = 101, CKSEL = 1101, SUT = 01
;* ;      REMCONT V1.0a
;*******************************************************************************

.nolist
.include "m8def.inc"
.EQU ROLSEN=1
.EQU AverTV350=2
.list

.EQU Pult=ROLSEN

;***** *****

.def	ZeroL = r1   ;      '0',  
.def	ZeroH = r2   ;      '0',      
.def	UnitL = r3   ;      '1',       
.def	UnitH = r4   ;      '1',       
.def	StartbL = r5 ;       ,      
.def	StartbH = r6 ;       ,      
.def	Comm = r7    ;   
.def	InvComm = r8 ;       
.def	Addr1 = r9     ;    
.def	Addr2 = r10    ;    
;.def	 = r11     ; 
.def	Save = r12     ;   SREG  
.def    Stime = r13    ;  '' 
.def    NumImpL = r14  ;     . T1,  
.def	NumImpH = r15  ;     . T1,  
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	Dbyt = r18     ;     -
;.def	 =  r19  ; 
.def	t3 = r20       ;   
.def	CntComm = r21  ;   
.def	OutComm = r22  ;    
.def	CntInt = r23   ;    
.def	time = r24     ;   
;.def	Cnt = r25      ;   
             

;*****  *****

.equ	ConsZH= $04    ;     '0', 
.equ    ConsZL= $4C    ;     '0', 
.equ    ConsUH= $08    ;     '1', 
.equ    ConsUL= $98    ;     '1',  
.equ    ConsSH= $13    ;     , 
.equ    ConsSL= $88    ;     , 
.equ    Cons1= 14	   ;    ()  
.equ    Cons2= 12	   ;      PORTB
.equ    Cons3= 13	   ;      PORTC
                       
.cseg

.org 0
	rjmp Initial   ;   / 

.org 2             ;   /    INT1
    rjmp EXT_INT1
    
Initial:	
	
	ldi   t1,High(RamEnd) 
    out   sph,t1
    ldi   t1,Low(RamEnd)
    out   spl,t1	    ;  
    ldi t1,0b11110110    
    out	PORTD,t1        ; PORTD -  , PD0- , PD3- -
    ldi t1,0
	out	DDRD,t1          
    ser t1
    out	DDRB,t1	  
	out	DDRC,t1
	out	PORTB,t1        ; PORTB -  
	out	PORTC,t1        ; PORTC -  		    
	ldi   t1,7	        ;  
    out   TCCR2,t1      ;  T/C2,  . = 1024
    rcall Wait500       ;        
    ldi   t1,0b10000000
	out   GICR,t1       ;    INT1
    ldi   t1,0b00001100
	out   MCUCR,t1      ;    , INT1
	clr CntComm
	clr CntInt
    ldi t1,ConsZL       ;     
	mov ZeroL,t1
    ldi t1,ConsZH       ;     
	mov ZeroH,t1
    ldi t1,ConsUL       ;     
	mov UnitL,t1
    ldi t1,ConsUH       ;     
	mov UnitH,t1
    ldi t1,ConsSL       ;     
	mov StartbL,t1
    ldi t1,ConsSH       ;     
	mov StartbH,t1
	rjmp Main 
	 
Wait50us:	    ;    = 8,0 
ldi   time,130	;  
Wait501:
dec   time
brne  Wait501
ret

Wait05ms:	    ;    = 8,0 
ldi   t2,10	    ;  
Wait502:
rcall wait50us
dec   t2
brne  Wait502
ret

Wait150:        	;   0,15 
ldi   t1,0	        ;   
out   TCNT2,t1  	;  T/C2
ldi   t1,1<<TOV2	;     TOV2
out   TIFR,t1	    ;   TOV2
ldi   time,5	    ; 5   
Wait301:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV2	    ;   ,   - 
rjmp  Wait301	    ;   
ldi   t1,1<<TOV2	;     TOV2
out   TIFR,t1    	;   TOV2
dec   time
brne  Wait301	    ; 5  = 0,15 
ret

Wait500:        	;   0,5 
ldi   t1,0	        ;   
out   TCNT2,t1  	;  T/C2
ldi   t1,1<<TOV2	;     TOV2
out   TIFR,t1	    ;   TOV2
ldi   time,16	    ; 16   
Wait:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV2	    ;   ,   - 
rjmp  Wait	        ;   
ldi   t1,1<<TOV2	;     TOV2
out   TIFR,t1    	;   TOV2
dec   time
brne  Wait	        ; 16  = 0,5 
ret

Main:    ;  

clr r29             ;   SRAM
ldi r28,$0060
ldi Dbyt,$80        ;   
clr CntComm         ;     ,
clr CntInt          ;    
sei
clr CntComm
clr CntInt
Main2:              ;  
cpi CntInt,34       
breq MN0            ;   
rjmp Main2
MN0:
cli                 ;       
rjmp OutCommand     ;   /     

EXT_INT1:  ;    

    in Save,SREG          ;    
    push t1
    inc CntInt
	cpi CntInt,2          ;  ,   
	breq EI1
    cpi CntInt,3          ;     
	brsh EI3
    ldi   t1,2	          ;  
    out   TCCR1B,t1       ;  T/C1,  . = 8
    pop t1                ;    
    out SREG,Save
	reti	
EI1:
    clr  t1
    out   TCCR1B,t1       ;  T/C1
    in   NumImpL,TCNT1L   ;     T1
    in   NumImpH,TCNT1H
    out   TCNT1H,t1       ;    T1
    out   TCNT1L,t1
    ldi   t1,2	          ;  
    out   TCCR1B,t1       ;  T/C1,  . = 8
	cp  NumImpL,StartbL   ;   
    cpc NumImpH,StartbH
    brsh EI2
    ldi t1,2              ;  '',   
    mov Stime,t1
    rcall ALARM           ;  /  
EI2:
	pop t1                ;    
	out SREG,Save
	reti
EI3:
	clr  t1
    out   TCCR1B,t1       ;  T/C1
    in   NumImpL,TCNT1L   ;     T1
    in   NumImpH,TCNT1H
    out   TCNT1H,t1       ;    T1
    out   TCNT1L,t1
    ldi   t1,2	          ;  
    out   TCCR1B,t1       ;  T/C1,  . = 8
	cp  NumImpL,UnitL
    cpc NumImpH,UnitH     ;    = 1,   
    brpl RB3
    cp  NumImpL,ZeroL
    cpc NumImpH,ZeroH     ;    = 0,   
    brpl RB2
    subi CntInt,1      ;   ,   
	pop t1                ;    
	out SREG,Save
	reti    
RB2:
    clc                   ;   , C=0
    ror Dbyt              ;     
    rjmp RB4
RB3:
    sec                   ;   , C=1
    ror Dbyt              ;     
RB4:
    brcc EI4              ;    ,   
    st Y+,Dbyt            ;     SRAM
    ldi Dbyt,$80          ;   
    pop t1                ;    
	out SREG,Save
	reti
EI4: 	
    pop t1                ;    
	out SREG,Save
	reti	

OutCommand:   ;     -                            

clr r29
ldi r28,$0060
ld Addr1,Y+         ;    SRAM
ld Addr2,Y+      
ld Comm,Y+
ld InvComm,Y

.IF Pult==AverTV350  ;       'AverTV 305'
com Addr2           
.ENDIF

cp Addr1,Addr2      ;   ,   ,   
breq OC1
ldi t1,3            ;  '',  
mov Stime,t1
rcall ALARM          ;  /  
rjmp Main 
OC1:
com InvComm         ;    
cp Comm,InvComm     ;   ,   ,   
breq OC2
ldi t1,4            ;  '',  
mov Stime,t1
rcall ALARM         ;  /  
rjmp Main
OC2:
ldi t1,1            ;  '',    
mov Stime,t1
rcall ALARM         ;  /  
OC3:
ldi zl,Low(TablComm<<1)  ;    Z 
ldi zh,High(TablComm<<1) ;     
clr t1
add zl,CntComm      ;   -,     
adc zh,t1
lpm                 ;   -  r0
cp Comm,r0          ;       
breq OC4            ;   ,   
inc CntComm         ;    
cpi CntComm,Cons1   ;   ,    
breq OC11           
rjmp OC3            ;    
OC11:
rjmp Main
OC4:
cpi CntComm,Cons2   ;   =12,   
breq OC8            
cpi CntComm,Cons3   ;   =13,   
breq OC9            
rjmp OC10
OC8:
ser OutComm
out PORTB,OutComm   ;  PORTB  '1',  
rjmp Main
OC9:
ser OutComm
out PORTC,OutComm   ;  PORT  '1',  
rjmp Main
OC10:
ldi zl,Low(CommOut<<1)  ;    Z 
ldi zh,High(CommOut<<1) ;     
clr t1
add zl,CntComm      ;   -,     
adc zh,t1
lpm                 ;   -  r0
cpi CntComm,6
brsh OC6
in OutComm,PORTC    ;   
or OutComm,r0       ;    '0'   
cpi OutComm,254     ;    
breq REP1
cpi OutComm,253
breq REP2
cpi OutComm,251
breq REP3
cpi OutComm,247
breq REP4
cpi OutComm,239
breq REP5
cpi OutComm,223
breq REP6
rjmp REP7
REP1:
sbi PORTC,0         ;  , 
rjmp Main           ;     PORTC
REP2:
sbi PORTC,1
rjmp Main 
REP3:
sbi PORTC,2
rjmp Main
REP4:
sbi PORTC,3
rjmp Main
REP5:
sbi PORTC,4
rjmp Main
REP6:
sbi PORTC,5
rjmp Main
REP7:
in OutComm,PORTC    ;    
and OutComm,r0      ;    ''
out PORTC,OutComm   ;   
rjmp OC7
OC6:
in OutComm,PORTB    ;   
or OutComm,r0       ;    '0'   
cpi OutComm,254     ;   
breq REP8
cpi OutComm,253
breq REP9
cpi OutComm,251
breq REP10
cpi OutComm,247
breq REP11
cpi OutComm,239
breq REP12
cpi OutComm,223
breq REP13
rjmp REP14
REP8:
sbi PORTB,0         ;  , 
rjmp Main           ;     PORTB
REP9:
sbi PORTB,1
rjmp Main 
REP10:
sbi PORTB,2
rjmp Main
REP11:
sbi PORTB,3
rjmp Main
REP12:
sbi PORTB,4
rjmp Main
REP13:
sbi PORTB,5
rjmp Main
REP14:
in OutComm,PORTB    ;     
and OutComm,r0      ;    ''
out PORTB,OutComm   ;   
OC7:
rjmp Main

ALARM:    ;    

cli
ldi  t3,100         ;   ,  
                    ;    
REP15:
sbi DDRD,0          ;   
rcall Wait05ms      
cbi DDRD,0          
rcall Wait05ms 
dec  t3
cpi  t3,0
breq REP16     
rjmp REP15
REP16:
rcall Wait150       ;    
dec Stime           ;     
mov t3,Stime        ;  Stime   '' 
cpi t3,0            ;   0
breq REP17          ; ,  0
rjmp ALARM
REP17:
ret 

.IF Pult==ROLSEN  
.MESSAGE "ROLSEN"                            

TablComm:      
;   
;  "ROLSEN"
;       '1'        '2'
.db 0b00000000, 0b00000001
;       '3'        '4'
.db 0b00000010, 0b00000011
;       '5'        '6'
.db 0b00000100, 0b00000101
;       '7'        '8'
.db 0b00000110, 0b00000111
;       '9'        '0'
.db 0b00001000, 0b00001001
;    'STANDBY'   'TV/AV'
.db 0b00001011, 0b00001100
;       '<='        '=>'
.db 0b00010010, 0b00010011
.db 0b11111111, 0b11111111

.ENDIF

.IF Pult==AverTV350
.MESSAGE "AverTV350"

TablComm:
;   
;  "AverTV 305"
;       '1'        '2'
.db 0b00000101, 0b00000110
;       '3'        '4'
.db 0b00000111, 0b00001001
;       '5'        '6'
.db 0b00001010, 0b00001011
;     'TV/FM'      'CD'
.db 0b00000001, 0b00000010
;'   TELETEXT'   'POWER'
.db 0b00000011, 0b00000000
;     'VIDEO'    'AUDIO'
.db 0b00000100, 0b00001000
 ;    '<=VOL'    'VOL=>'
.db 0b00011110, 0b00011111
.db 0b11111111, 0b11111111

.ENDIF

CommOut:
;  , 
;   .
; PORTC
;       '1'         2'
.db 0b11111110, 0b11111101
;       '3'         4'
.db 0b11111011, 0b11110111
;       '5'         6'
.db 0b11101111, 0b11011111 
; PORTB
;       '7'        '8'
;    ('TV/FM')    ('CD')
.db 0b11111110, 0b11111101
;       '9'         0'
;  ('TELETEXT') ('POWER')
.db 0b11111011, 0b11110111
;    'STANDBY'   'TV/AV'
;    ('VIDEO')  ('AUDIO')
.db 0b11101111, 0b11011111


 



